
#property copyright " 2007 BJF Trading Group"
#property link      "www.fxstrategy.ca"

#define major   3
#define minor   0

#property  indicator_chart_window
#property  indicator_buffers 0

extern string _tmp1_ = " --- Common ---";
extern int Depth = 7;
extern int dy = 3;

extern bool TF.M1 = false;
extern bool TF.M5 = true;
extern bool TF.M15 = true;
extern bool TF.M30 = true;
extern bool TF.H1 = true;
extern bool TF.H4 = true;
extern bool TF.D1 = true;
extern bool TF.W1 = true;
extern bool TF.MN = true;

extern string _tmp2_ = " --- Graph. options ---";
extern int Corner = 0;
extern color Header = Gold;
extern color TimeFrame = Aqua;
extern color UpArrow = Lime;
extern color DownArrow = Red;
extern color NeutralSymbol = Yellow;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string prefix = "i-Trend_";
int TF[9];

void init() 
{
  ArrayInitialize(TF, -1);
  
  if (TF.M1)  TF[0] = PERIOD_M1;
  if (TF.M5)  TF[1] = PERIOD_M5;
  if (TF.M15) TF[2] = PERIOD_M15;
  if (TF.M30) TF[3] = PERIOD_M30;
  if (TF.H1)  TF[4] = PERIOD_H1;
  if (TF.H4)  TF[5] = PERIOD_H4;
  if (TF.D1)  TF[6] = PERIOD_D1;
  if (TF.W1)  TF[7] = PERIOD_W1;
  if (TF.MN)  TF[8] = PERIOD_MN1;

  clear();
  show();
}

void deinit() 
{
  clear();
}

void start() 
{
  show();
}

void show() 
{
  //-----
  
  int dx = 28;
  int window = 0;
    
  string name = "";
  string txt;

  int N = ArraySize(TF);
  int pos = 0;
  for (int i=0; i < N; i++) 
  {
    if (TF[i] == -1) continue;
    
    name = prefix + TF2Str(TF[i]) + "_timeframe";
    if (ObjectFind(name) == -1) {
      ObjectCreate(name, OBJ_LABEL, window, 0, 0);
    }
  
    ObjectSet(name, OBJPROP_XDISTANCE, 20);
    ObjectSet(name, OBJPROP_YDISTANCE, 60 + pos*20);
    ObjectSetText(name, TF2Str(TF[i]), 10, "Tahoma", TimeFrame);
    ObjectSet(name, OBJPROP_CORNER, Corner);
    
    pos++;
  }
  
  for (i=0; i < Depth; i++)
  {
    name = prefix + "_" + i + "bar";
    if (ObjectFind(name) == -1) {
      ObjectCreate(name, OBJ_LABEL, window, 0, 0);
    }
  
    ObjectSet(name, OBJPROP_XDISTANCE, 40 + (i+1)*dx);
    ObjectSet(name, OBJPROP_YDISTANCE, 35);
    txt = Depth-i-1;
    ObjectSetText(name, txt, 11, "Verdana", Header);
    ObjectSet(name, OBJPROP_CORNER, Corner);
  }

  name = prefix + "_" + "bars_total";
  if (ObjectFind(name) == -1) {
    ObjectCreate(name, OBJ_LABEL, window, 0, 0);
  }
  
  ObjectSet(name, OBJPROP_XDISTANCE, 40 + (Depth+2)*dx);
  ObjectSet(name, OBJPROP_YDISTANCE, 35);
  ObjectSetText(name, CharToStr(252), 12, "Wingdings", Header);
  ObjectSet(name, OBJPROP_CORNER, Corner);
 //Comment(TimeCurrent());
  //-----
  
  pos = 0;  
  for (i=0; i < N; i++) 
  {
    if (TF[i] == -1) continue;
  
    int cnt = 0;
    for (int j=0; j < Depth; j++) 
    {
      name = prefix + TF2Str(TF[i]) + "_" + j;
      if (ObjectFind(name) == -1) {
        ObjectCreate(name, OBJ_LABEL, window, 0, 0);
      }
      
      int shift = iBarShift(NULL, TF[i], iTime(NULL, TF[0], 0)) + Depth-j-1;
      //double res = iClose(NULL, TF[i], Depth-j-1)-iOpen(NULL, TF[i], Depth-j-1);
      double res = iClose(NULL, TF[i], shift)-iOpen(NULL, TF[i], shift);
             
      ObjectSet(name, OBJPROP_CORNER, Corner);
    
      if (res > dy*Point) {
        ObjectSet(name, OBJPROP_XDISTANCE, 38 + (j+1)*dx);
        ObjectSet(name, OBJPROP_YDISTANCE, 60 + pos*20);  
        ObjectSetText(name, CharToStr(225), 12, "Wingdings", UpArrow);
        cnt++;
      }
      else if (res < -dy*Point) {
        ObjectSet(name, OBJPROP_XDISTANCE, 38 + (j+1)*dx);
        ObjectSet(name, OBJPROP_YDISTANCE, 60 + pos*20);      
        ObjectSetText(name, CharToStr(226), 12, "Wingdings", DownArrow);
        cnt--;
      }
      else {
        ObjectSet(name, OBJPROP_XDISTANCE, 41 + (j+1)*dx);
        ObjectSet(name, OBJPROP_YDISTANCE, 60 + pos*20);
      
        ObjectSetText(name, CharToStr(159), 12, "Wingdings", NeutralSymbol);
      }
    }
        
    name = prefix + TF2Str(TF[i]) + "_trend";
    if (ObjectFind(name) == -1) {
      ObjectCreate(name, OBJ_LABEL, window, 0, 0);
    }
  
    ObjectSet(name, OBJPROP_CORNER, Corner);
   
    if (cnt > 0) {
      ObjectSet(name, OBJPROP_XDISTANCE, 40 + (Depth+2)*dx);
      ObjectSet(name, OBJPROP_YDISTANCE, 60 + pos*20);
      ObjectSetText(name, CharToStr(225), 12, "Wingdings", UpArrow);
    }
    else if (cnt < 0) {
      ObjectSet(name, OBJPROP_XDISTANCE, 40 + (Depth+2)*dx);
      ObjectSet(name, OBJPROP_YDISTANCE, 60 + pos*20);
      ObjectSetText(name, CharToStr(226), 12, "Wingdings", DownArrow);
    }
    else {
      ObjectSet(name, OBJPROP_XDISTANCE, 43 + (Depth+2)*dx);
      ObjectSet(name, OBJPROP_YDISTANCE, 60 + pos*20);
      ObjectSetText(name, CharToStr(159), 12, "Wingdings", NeutralSymbol);
    }
    
    pos++;
  }
}

void clear() 
{
  string name;
  int obj_total = ObjectsTotal();
  for (int i=obj_total-1; i>=0; i--)
  {
    name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
}

string TF2Str(int period) 
{
  switch (period) 
  {
    case PERIOD_M1: return("M1");
    case PERIOD_M5: return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1: return("H1");
    case PERIOD_H4: return("H4");
    case PERIOD_D1: return("D1");
    case PERIOD_W1: return("W1");
    case PERIOD_MN1: return("MN");
 }
 
  return (period);
}

